#
#  clickexam.cl
#

procedure       clickexam( imagefile, out_log )

file    imagefile       {prompt = "Input image for photometry"}
file    out_log         {prompt = "Output log file of flux, sky, and FWHM"}

struct  *list1    {mode = 'h'}
struct  *list2    {mode = 'h'}
#
#
begin
        string  tmpfile1, tmpfile2

        string  junk1, junk2, junk3, junk4, junk5, junk6, junk7

        string  image1, coords1

        string  out_log1

        int     i

        real    x, y, xc, yc, fwhm

	real x_s, y_s, flux_s, sky_s, peak_s,elip,pa,beta, fwhm_s

        string  wcs
        struct  command
        string  key


##
        image1 = imagefile
        out_log1 = out_log


        list1 = ""
        list2 = ""


        tmpfile1  = mktemp( "tmp_file." )
        tmpfile2  = mktemp( "tmp_file." )

        delete( out_log1,ver-,>&"dev$null" )
        print( "Measure position using mouse pointer." )

        print( "Move cursor to a object ")
        print( " and push   "  )
        print( "           a to imexam " ) 
        print( "           p to get coordinate " ) 
        print( "           q to finish")



        display(image1,1,zs+,zr+,z1=INDEF,z2=INDEF,fi+)
        while( fscan( imcur, x, y, wcs, command) != EOF)
        {
        key = substr(command,1,1)
        if( key == 'a')
             {
             delete( tmpfile1,ver-,>&"dev$null" )
             delete( tmpfile2,ver-,>&"dev$null" )

             print(":",x,y," a", >> tmpfile1)
             print(":center yes", >> tmpfile1)
             print(":fittype gaussian", >> tmpfile1)
             print(":iterations 1", >> tmpfile1)
             print(":radius 10", >> tmpfile1)
             print(":buffer 10", >> tmpfile1)
             print(":width 10", >> tmpfile1)

             wcsreset( image1, "physical" )
             imexam(image1,use_display=yes,logfile=tmpfile2,keeplog+,graphcur+, imagecur=tmpfile1,wcs="physical", graphic="stdgraph")
             list1 = tmpfile2

	     if(fscan(list1,junk1) == 1){
		if(fscan(list1,junk1) == 1){
		if(fscan(list1,x_s,y_s,junk1,junk1,junk1,junk1,flux_s,sky_s,peak_s,elip,pa,junk3,fwhm_s,junk4) == 14){
		x=x_s
		y=y_s
		flux=flux_s
		sky=sky_s
		peak=peak_s
		fwhm=fwhm_s
		print("x=",x," y=",y," FWHM=",fwhm)
	     }}}
	     }
	else if( key == 'p'){
		print("x=",x," y=",y)
	}
	else if( key == 'q') break
	else {
	print("Wrong Key!!")
	beep
	}
	}

        print(x,y, >> out_log1)

finish:
	delete( tmpfile1,ver-,>&"dev$null" )
        delete( tmpfile2,ver-,>&"dev$null" )
end
