#
#  cutout.cl
#
#  use noao.digiphot.daophot.daofind/tvmark and photexam.cl first !
#  use noao.imred.irred.irmosaic for mosaicing the resultant images
#

procedure       cutout( image, output, coords, xmag, ymag, ncols, nlines, st_log )

file    image           {prompt = "Input image"}
file    output          {prompt = "Output image"}
file    coords          {prompt = "Input coordinate list"}
real    xmag            {prompt = "X output pixels per input pixel"}
real    ymag            {prompt = "Y output pixels per input pixel"}
int     ncols           {prompt = "Number of columns in the output image"}
int     nlines          {prompt = "Number of lines in the output image"}
file    st_log          {prompt = "Log file of flux, sky, and FWHM of the objects"}

struct  *list1    {mode = 'h'}
struct  *list2    {mode = 'h'}
struct  *list3    {mode = 'h'}
#
#
begin
        string  tmpfile1, tmpfile2, tmpfile3

        string  junk2, junk3, junk4, junk5, junk6, junk7, junk8, junk9

        string  tmpimage1

        string  image1, output1, coords1

        string  st_log1

        int     i

        real    x_mag, y_mag
        real    flux1, sky1, el1, pa1, fwhm1
        real    flux2, sky2, el2, pa2, fwhm2
        real    flux3, sky3, el3, pa3, fwhm3
        real    flux4, sky4, el4, pa4, fwhm4
        real    flux5, sky5, el5, pa5, fwhm5
        real    flux6, sky6, el6, pa6, fwhm6

        real    x, y, fl1, fl2, fl3, sk, x_in, y_in

        image1 = image
        output1 = output
        coords1 = coords
        st_log1 = st_log

        list1 = coords1
        list2 = ""
        list3 = ""
        tmpfile1  = mktemp( "tmp_file." )
        tmpfile2  = mktemp( "tmp_file." )
        tmpfile3  = mktemp( "tmp_file." )
        x_mag = 1/xmag
        y_mag = 1/ymag

        while( fscan ( list1, i, x, y, fl1, junk2, junk3, junk4, junk5, fl2, junk6, junk7, junk8, junk9, fl3 ) != EOF )
            {
            delete( tmpfile1,ver-,>&"dev$null" )
            delete( tmpfile2,ver-,>&"dev$null" )
            print(":",x,y," ,", >> tmpfile1)
            print(":center no", >> tmpfile1)
            print(":fittype gaussian", >> tmpfile1)
            print(":iterations 1", >> tmpfile1)
            print(":radius 5", >> tmpfile1)
            print(":buffer 5", >> tmpfile1)
            print(":width 5", >> tmpfile1)
            print(":",x,y," ,", >> tmpfile1)
            print(":radius 10", >> tmpfile1)
            print(":buffer 10", >> tmpfile1)
            print(":width 10", >> tmpfile1)
            print(":",x,y," ,", >> tmpfile1)
            print(":radius 15", >> tmpfile1)
            print(":buffer 15", >> tmpfile1)
            print(":width 15", >> tmpfile1)
            print(":",x,y," ,", >> tmpfile1)
            print(":radius 20", >> tmpfile1)
            print(":buffer 20", >> tmpfile1)
            print(":width 20", >> tmpfile1)
            print(":",x,y," ,", >> tmpfile1)
            print(":radius 3", >> tmpfile1)
            print(":buffer 3", >> tmpfile1)
            print(":width 3", >> tmpfile1)
            print(":",x,y," ,", >> tmpfile1)
            print(":radius 4", >> tmpfile1)
            print(":buffer 4", >> tmpfile1)
            print(":width 4", >> tmpfile1)
            print(":",x,y," ,", >> tmpfile1)
            print(":center yes", >> tmpfile1)
            print(":radius 5", >> tmpfile1)
            print(":buffer 5", >> tmpfile1)
            print(":width 5", >> tmpfile1)
            wcsreset( image1, "physical" )
            imexam( image1, logfile=tmpfile2,keeplog+,graphcur-, imagecur=tmpfile1,wcs="physical", graphic="stdgraph",use_dis+ )
            list2 = tmpfile2
            if( fscan( list2, junk2 ) == 1){
            if( fscan( list2, junk2 ) == 1){
            if( fscan( list2, junk2 ) == 1){
                if( fscan( list2, junk2, junk3, junk4, flux1, sky1, junk5, junk6, el1, pa1, junk7, fwhm1) == 11){
                if( fscan( list2, junk2, junk3, junk4, flux2, sky2, junk5, junk6, el2, pa2, junk7, fwhm2) == 11){
                if( fscan( list2, junk2, junk3, junk4, flux3, sky3, junk5, junk6, el3, pa3, junk7, fwhm3) == 11){
                if( fscan( list2, junk2, junk3, junk4, flux4, sky4, junk5, junk6, el4, pa4, junk7, fwhm4) == 11){
                if( fscan( list2, junk2, junk3, junk4, flux5, sky5, junk5, junk6, el5, pa5, junk7, fwhm5) == 11){
                if( fscan( list2, junk2, junk3, junk4, flux6, sky6, junk5, junk6, el6, pa6, junk7, fwhm6) == 11){
                    delete( tmpfile3,ver-,>&"dev$null" )
                    if(i<10) print( output1,".00",i, >> tmpfile3 )
                    else if(i<100) print( output1,".0",i, >> tmpfile3 )
                    else print( output1,".",i, >> tmpfile3 )
                    list3 = tmpfile3
                    print( list3, x, y, flux1, sky1, el1, pa1, fwhm1, flux2, sky2, el2, pa2, fwhm2, flux3, sky3, el3, pa3, fwhm3, \
                                        flux4, sky4, el4, pa4, fwhm4, flux5, sky5, el5, pa5, fwhm5, flux6, sky6, el6, pa6, fwhm6, >> st_log1 )
                    list3 = tmpfile3
                    if( fscan( list3, junk2 ) == 1){
                        x_in=x-ncols*x_mag/2
                        y_in=y-nlines*y_mag/2
                        if(x_in<1) x_in=1
                        if(y_in<1) y_in=1
       imlintran( image1, junk2, 0., 0., x_mag, y_mag, xin=x_in, yin=y_in, xout=1., yout=1., ncols=ncols, nlines=nlines, interpo="linear", fluxcon+ )
                        if(fl1 < 1e-5) {
                          if(fl2 < 1e-5) {
                            if(fl3 < 1e-5) fl1 = 1e-5
                            else fl1 = fl3
                            }
                          else fl1 = fl2
                          }
                        sk  = sky3 * x_mag * y_mag
                        fl1 = fl1/10000.
                        imarith( junk2, "-", sk, junk2 )
                        imarith( junk2, "/", fl1, junk2 )
                        }
                    }}}}}}
               }}}
            }
        print( 'Deleting Temporaly Files ...' )
        delete( tmpfile1,ver-,>&"dev$null" )
        delete( tmpfile2,ver-,>&"dev$null" )
        delete( tmpfile3,ver-,>&"dev$null" )
        bye
end
